function FARplots(ff,cut,mcPath)  
% FARplots :
% DESCRIPTION :
% This macro is used to plot FAR curves from
% several FAR ASCII files generated by the FAR.m
% 
% SYNTAX :
%   FARplots (folder,cut,mcPath)
% 
% INPUT : 
%   folder : figure folder
%   cut : cut array, by defaut 'noCut'
%   mcPath [OPTIONAL] : path to a mc dag
% 
% AUTHOR : 
%   MAB
%   Valentin FREY    
%
% CONTACT : 
%   mabizoua@lal.in2p3.fr
%   valentin.frey@gmail.com
%
% VERSION : 1.2
% DATE : Mar 2016
%
  import classes.utils.waitbar

  %---------------------------------------------------------------------
  %% INIT
  %---------------------------------------------------------------------
  % 
  % parse & check input 
  %

  switch nargin
    case 1
      mc=false;
      cut={'noCut'};

    case 2
      mc=false;
      if isempty(cut)
        cut={'noCut'};
      end

    case 3
      if ~isempty(mcPath)
        mc=true;
      else
        mc=false;
      end

      if isempty(cut)
        cut={'noCut'};
      end
      
    otherwise
      error('wrong number of input')
  end

  if mc
    if exist([mcPath '/figures/FAR_clean.mat'])==2
      dataMC=load([mcPath '/figures/FAR_clean.mat']);
    else
      waitbar.warning(['Warning: No MC FAR file has been found in ' ...
                       mcPath '/figures/FAR_clean.mat']);
    end
  end

  %---------------------------------------------------------------------
  %% MAIN 
  %---------------------------------------------------------------------
  % 
  % plot FAR for various cut
  %
  cc=flipud(colormap(gray(numel(cut)+2)));
  cc=cc(2:end,:); % remove the white color



  %% ALL TRIGGERS
  %---------------------------------------------------------------------
  % 
  % plot FAR for all triggers
  %
  all=load([ff '/FAR_noCut.mat']);
  leg = 'All triggers';

  if max(all.snr) > 30
    % define boudary of the plot
    xmax = min(100*ceil(max(all.snr(all.far~=0))*1.1/100),500);
    xmin = max(min(all.snr),10);
  else
    xmax = min(100*ceil(max(all.snr(all.far~=0))*1.1/100),30);
    xmin = max(min(all.snr),1);
  end
  ymin=10^(log10(min(all.far(all.far~=0)))*1.1);
  ymax=10^(log10(max(all.far))*0.9);


  figure;
  ax=gca();

  nsall=all.snr(all.snr<xmax&all.snr>xmin);
  nfall=min(max(all.far(all.snr<xmax&all.snr>xmin),ymin),ymax);

  set(ax,'XLim',[xmin xmax]);
  set(ax,'YLim',[ymin 2*10^-2]);
  set(ax,'XScale','log');
  set(ax,'YScale','log');
  set(ax,'XGrid','on');
  set(ax,'YGrid','on');
  set(get(ax,'XLabel'),'String','SNR');
  set(get(ax,'YLabel'),'String','FAR');
  set(ax,'Box','on');

  hold on
  bar(nsall,nfall, ...
      'FaceColor', cc(1,:), ...
      'EdgeColor', cc(1,:), ...
      'BarWidth', 1, ...
      'basevalue', ymin,'Parent',ax);

  dx=nsall(2)-nsall(1);
  stairs(nsall-dx/2,nfall, 'Color', [0 0 0],'Parent',ax)
  
  if mc
    leg=[leg 'MC'];
    stairs(dataMC.snr-dx/2,dataMC.far, 'Color','c','Parent',ax)
  end

  hold off

  legend(leg)
  title('FAR for all triggers');
  make_png(ff, 'FAR_all');
  


  %% FAR CUT COMPARARISON 
  %---------------------------------------------------------------------
  % 
  % plot FAR for various cut
  %
  for c=cut
    if strcmp(c{:},'noCut');
      continue
    end
    cdata = load([ff '/FAR_' c{:} '.mat']);
    
    leg = {decode(c{:})};
    
    figure;
    hold on
    ax=gca();
    
    set(ax,'XLim',[xmin xmax]);
    set(ax,'YLim',[ymin 2*10^-2]);
    set(ax,'XScale','log');
    set(ax,'YScale','log');
    set(ax,'XGrid','on');
    set(ax,'YGrid','on');
    set(get(ax,'XLabel'),'String','SNR');
    set(get(ax,'YLabel'),'String','FAR');
    set(ax,'Box','on');

    % cut data 
    % /!\ matlab bug if you want to plot bar in log scale 
    % so to fix that we cut data
    %
    nsnr=cdata.snr(cdata.snr<xmax&cdata.snr>xmin);
    nfar=min(max(cdata.far(cdata.snr<xmax&cdata.snr>xmin),ymin),ymax);

    % plot data
    bar(nsall,nfall, ...
        'FaceColor', cc(1,:), ...
        'EdgeColor', cc(1,:), ...
        'BarWidth', 1, ...
        'basevalue', ymin,'Parent',ax);
    
    dx=nsnr(2)-nsnr(1);

    bar(nsnr,nfar, ...
        'FaceColor', cc(find(strcmp(c{:},cut)),:), ...
        'EdgeColor', cc(find(strcmp(c{:},cut)),:), ...
        'BarWidth', 1, ...
        'basevalue', ymin,'Parent',ax);
    
    dx=nsnr(2)-nsnr(1);
    stairs(nsnr-dx/2,nfar, 'Color', [0 0 0],'Parent',ax)
    stairs(nsnr-dx/2,nfall, 'Color', [0 0 0],'Parent',ax)

    
    if mc
      leg=[leg 'MC'];
      stairs(dataMC.snr-dx/2,dataMC.far, 'Color','c','Parent',ax)
    end

    
    hold off
    legend(['All triggers', leg]);
    make_png([ff '/' c{:}], ['FAR']);
  end

  %% FAR CLEAN
  %---------------------------------------------------------------------
  % 
  % plot FAR after all cut
  %
  xclean=load([ff '/FAR_clean.mat']);
  leg = {'Without Cut', 'All Cut'};
  
  figure;
  hold on
  ax=gca();

  set(ax,'XLim',[xmin xmax]);
  set(ax,'YLim',[ymin 2*10^-2]);
  set(ax,'XScale','log');
  set(ax,'YScale','log');
  set(ax,'XGrid','on');
  set(ax,'YGrid','on');
  set(get(ax,'XLabel'),'String','SNR');
  set(get(ax,'YLabel'),'String','FAR');
  set(ax,'Box','on');

  % cut data 
  % /!\ matlab bug if you want to plot bar in log scale 
  % so to fix that we cut data
  %
  nsnr=xclean.snr(xclean.snr<xmax&xclean.snr>xmin);
  nfar=min(max(xclean.far(xclean.snr<xmax&xclean.snr>xmin),ymin),ymax);

  % plot data
  bar(nsall,nfall, ...
      'FaceColor', cc(1,:), ...
      'EdgeColor', cc(1,:), ...
      'BarWidth', 1, ...
      'basevalue', ymin,'Parent',ax);

  dx=nsnr(2)-nsnr(1);

  bar(nsnr,nfar, ...
      'FaceColor', cc(end,:), ...
      'EdgeColor', cc(end,:), ...
      'BarWidth', 1, ...
      'basevalue', ymin,'Parent',ax);

  dx=nsnr(2)-nsnr(1);
  stairs(nsnr-dx/2,nfar, 'Color', [0 0 0],'Parent',ax)
  stairs(nsnr-dx/2,nfall, 'Color', [0 0 0],'Parent',ax)
  
  if mc
    leg=[leg 'MC'];
    stairs(dataMC.snr-dx/2,dataMC.far, 'Color','c','Parent',ax)
  end


  hold off
  legend(leg)
  title('FAR after all cut')
  make_png(ff, ['FAR_clean']);
  clear snr far 

  %% CUMULATIVE CUT FAR
  %---------------------------------------------------------------------
  % one plot with all cut
  %
  xcum=load([ff '/FAR_cumulative.mat']);
  close all
  figure(1)
  hold on
  ax=gca();

  set(ax,'XLim',[xmin xmax]);
  set(ax,'YLim',[ymin 2*10^-2]);
  set(ax,'XScale','log');
  set(ax,'YScale','log');
  set(ax,'XGrid','on');
  set(ax,'YGrid','on');
  set(get(ax,'XLabel'),'String','SNR');
  set(get(ax,'YLabel'),'String','FAR');
  set(ax,'Box','on');
  hg = hggroup;
  try
    xcum.snr;
  catch
    xcum.snr = [];
  end

  for i=1:size(xcum.snr,2)
    nsall=xcum.snr(xcum.snr(:,i)<xmax&xcum.snr(:,i)>xmin,1);
    nfall=min(max(xcum.far(xcum.snr(:,i)<xmax&xcum.snr(:,i)>xmin,i),ymin),ymax);

    bar(nsall,nfall, ...
        'FaceColor', cc(i,:), ...
        'EdgeColor', cc(i,:), ...
        'BarWidth', 1, ...
        'basevalue', ymin,'Parent',ax);
  
    dx=nsall(2)-nsall(1);
    stairs(nsall-dx/2,nfall, 'Color', [0 0 0],'Parent',hg);
  end
  hold off

  uistack(hg,'bottom');
  legend(xcum.leg);
  uistack(hg,'top');
  title('FAR for cumulative cut');
  make_png(ff, ['FAR_cumulative']);
  clear xcum;

end
